
CREATE DATABASE relation_test;
USE relation_test;

#
# Host: localhost
# Generation Time: Thu, 25 Mar 2004 15:07:37 +0200
# mySQL server version: 4.0.15-max
# PHP Version: 4.3.3
# 
# Database : TEST
#


#--------------------------------------------------------------------------
# Table structure for table parent
#--------------------------------------------------------------------------

# drop table parent
DROP TABLE IF EXISTS  parent;
#

CREATE TABLE parent (
       id int(11) NOT NULL default '0',
       PRIMARY KEY  (id)
     ) TYPE=InnoDB;

#
# Dumping data for table parent
#

INSERT INTO parent (id) VALUES 
(3),
(25);


#--------------------------------------------------------------------------
# Table structure for table product
#--------------------------------------------------------------------------

# drop table product
DROP TABLE IF EXISTS  product;
#

CREATE TABLE product (
       category int(11) NOT NULL default '0',
       id int(11) NOT NULL default '0',
       price decimal(10,0) default NULL,
       PRIMARY KEY  (category,id)
     ) TYPE=InnoDB;


#--------------------------------------------------------------------------
# Table structure for table alfa
#--------------------------------------------------------------------------

# drop table alfa
DROP TABLE IF EXISTS  alfa;
#

CREATE TABLE alfa (
       MYKEY int(11) NOT NULL default '0',
       PRIMARY KEY  (MYKEY)
     ) TYPE=InnoDB;

#
# Dumping data for table alfa
#

INSERT INTO alfa (MYKEY) VALUES 
(1),
(2),
(3);


#--------------------------------------------------------------------------
# Table structure for table customer
#--------------------------------------------------------------------------

# drop table customer
DROP TABLE IF EXISTS  customer;
#

CREATE TABLE customer (
       id int(11) NOT NULL default '0',
       PRIMARY KEY  (id)
     ) TYPE=InnoDB;


#--------------------------------------------------------------------------
# Table structure for table product_order
#--------------------------------------------------------------------------

# drop table product_order
DROP TABLE IF EXISTS  product_order;
#

CREATE TABLE product_order (
       no int(11) NOT NULL auto_increment,
       product_category int(11) NOT NULL default '0',
       product_id int(11) NOT NULL default '0',
       customer_id int(11) NOT NULL default '0',
       PRIMARY KEY  (no),
       KEY product_category (product_category,product_id),
       KEY customer_id (customer_id),
       CONSTRAINT `0_2053` FOREIGN KEY (`product_category`, `product_id`) REFERENCES `product` (`category`, `id`) ON UPDATE CASCADE,
       CONSTRAINT `0_2054` FOREIGN KEY (`customer_id`) REFERENCES `customer` (`id`)
     ) TYPE=InnoDB AUTO_INCREMENT=1 ;


#--------------------------------------------------------------------------
# Table structure for table beta
#--------------------------------------------------------------------------

# drop table beta
DROP TABLE IF EXISTS  beta;
#

CREATE TABLE beta (
       BETAKEY int(11) NOT NULL default '0',
       FK_ALFAKEY int(11) NOT NULL default '0',
       PRIMARY KEY  (BETAKEY),
       KEY fk_idx_alfa_mykey (FK_ALFAKEY),       
       CONSTRAINT `0_2159` FOREIGN KEY (`FK_ALFAKEY`) REFERENCES `alfa` (`MYKEY`) ON DELETE NO ACTION
     ) TYPE=InnoDB;

#
# Dumping data for table beta
#

INSERT INTO beta (BETAKEY, FK_ALFAKEY) VALUES 
(0, 1),
(1, 2);


#--------------------------------------------------------------------------
# Table structure for table child
#--------------------------------------------------------------------------

# drop table child
DROP TABLE IF EXISTS  child;
#

CREATE TABLE child (
       id int(11) default NULL,
       parent_id int(11) default NULL,
       KEY par_ind (parent_id),
       CONSTRAINT `0_2049` FOREIGN KEY (`parent_id`) REFERENCES `parent` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
     ) TYPE=InnoDB;

