﻿//----------------------------------------------------------------------------------------------//
init();
stop();
//----------------------------------------------------------------------------------------------//
function init()
{
  parent = _parent._parent;
  
  fields = new Array();
  current_item = 0;
 
 //set combobox listener
  combo_listener = new Object(); 
  
  field_type_cb.addEventListener("change", combo_listener);
  field_type_cb.dataProvider = parent.types;
   
  tabtype_cb.dataProvider = parent.tabtypes;
  
 //set list listener
  list_listener = new Object();
  fields_lb.addEventListener("change", list_listener);
  
 //set buttons listener
  btn_listener = new Object();
    
  add_btn.addEventListener("click", btn_listener);
  create_btn.addEventListener("click", btn_listener);
  change_btn.addEventListener("click", btn_listener);
  cancel_btn.addEventListener("click", btn_listener);
  remove_btn.addEventListener("click", btn_listener);

  field_size_txt.restrict = "0-9";
  parent.set_def_prop(this);
  
  set_default_window();
  
  this.Show(this.args);
}

btn_listener.click = function(evt)
{
   switch(evt.target._name)
   {
	case "add_btn"    : add_pressed();    break;
	case "create_btn" : create_pressed(); break;
	case "change_btn" : change_pressed(); break;
	case "cancel_btn" : cancel_pressed(); break;
	case "remove_btn" : remove_pressed(); break;
   }
}

combo_listener.change = function(evt)
{
   field_type_pressed();
}

list_listener.change = function(evt)
{
   fields_list_pressed();
}

function Show(args)
{
    this._visible = true;
}
//----------------------------------------------------------------------------------------------//
function field_type_pressed() {
  parent.tab1_mc.settype_conditions(field_type_cb.selectedItem, this);
}

function fields_list_pressed(success){
 
    fieldname_txt.text = fields_lb.selectedItem.label;
  
   //save previous field
	if (success != false) setfield();
    	
	current_item = fields_lb.selectedIndex;
		  
    for(var i = 0; i < parent.types.length; i++) {
		if (parent.types[i] == fields[current_item].field_type) {
	        field_type_cb.selectedIndex = i;
			parent.tab1_mc.settype_conditions(field_type_cb.selectedItem, this);
		    break;
		}
    }
 	 	 
    field_size_txt.text = fields[current_item].field_size;
    field_default_txt.text = fields[current_item].default_value;
    
    unsigned_chk.selected = fields[current_item].unsigned;
    null_chk.selected     = fields[current_item].null;
    autoinc_chk.selected  = fields[current_item].auto_inc;
    index_chk.selected    = fields[current_item].index;
    prikey_chk.selected   = fields[current_item].prikey;
    unique_chk.selected   = fields[current_item].unique;
    
}

function create_pressed() 
{
  if (fields_lb.length > 0) setfield();
  gen_addtab_xml();
}

function change_pressed() 
{
  fields_lb.replaceItemAt(current_item, fieldname_txt.text);
  fields[current_item].field_name = fields_lb.getItemAt(current_item).label;  
}

function remove_pressed() {
  var del_index = fields_lb.selectedIndex;
  if(del_index != undefined)
  {
   fields_lb.removeItemAt(del_index);
   fields.splice(del_index, 1);
   if (fields.length > 0) 
   {
	   fields_lb.selectedIndex = (del_index > fields_lb.length-1)? fields_lb.length-1 : del_index;
	   fields_list_pressed(false);
   }
   else set_down_part();
  }
  
  trace("REMOVE FIELD");
  parent.ex_trace(fields);
}

function cancel_pressed() {
   parent.hideWindowPopUp( parent.addtable_mc);
   set_default_window();
}

function add_pressed() {
   
   fieldname_txt.text = parent.trim( fieldname_txt.text );
   
   if(length(fieldname_txt.text) != 0) 
   {
	 var double_field = false;
	 for(var i=0; i < fields_lb.getLength(); i++)
	     if(fields_lb.getItemAt(i).label == fieldname_txt.text)
		 {
		     	var args = new Object();
			
			args.msg = parent.str_replace(parent.error_msg["tab1_crtab"], "%name%", fieldname_txt.text);
			args.name = "on_error_ok_pressed";
			args.link = parent.addtable_mc.content;
			
			parent.showWindowPopUp("message_mc", args);
			
			double_field = true;
			break;
		 }
	 
		 
	 if(!double_field) 
	 {
	   if(fields_lb.length > 0) setfield();
	   
	   field_type_cb.selectedIndex = 0;
	   parent.tab1_mc.settype_conditions(field_type_cb.selectedItem, this);
	   
	   current_item = fields_lb.length;
	   fields_lb.addItem(fieldname_txt.text);
	   fields_lb.selectedIndex = current_item;
	 }
	 
   }
   
  // trace("ADD FIELD");
  // parent.ex_trace(fields);

}

function setfield()
{  
    var tmp_name;
	if(fields_lb.getItemAt(current_item).label != "" && fields_lb.getItemAt(current_item).label != undefined)
	   tmp_name = fields_lb.getItemAt(current_item).label;
	else tmp_name = fieldname_txt.text;
		
	var f_size    = (field_size_txt.enabled)? field_size_txt.text : "";
	var f_default = (field_default_txt.enabled)? field_default_txt.text : "";

	
	var field={
				field_type    : field_type_cb.selectedItem,
				field_size    : f_size,
				unsigned      : unsigned_chk.selected,
				auto_inc      : autoinc_chk.selected,
				null          : null_chk.selected,
				index         : index_chk.selected,
				prikey        : prikey_chk.selected,
				unique        : unique_chk.selected,
				field_name    : tmp_name,
				default_value : f_default
			};
    	
	if(fields[current_item].field_name == field.field_name) fields[current_item] = field;
    else fields.push(field);
    
    trace("SET FIELD");
    parent.ex_trace(fields);
     
}

function set_down_part () {
  fieldname_txt.text = "";
  field_type_cb.selectedIndex = 0;
  fields_lb.removeAll();
  parent.tab1_mc.settype_conditions(field_type_cb.selectedItem, this);
  
  unique_chk.selected   = false;
  prikey_chk.selected   = false;
  index_chk.selected    = false;
  autoinc_chk.selected  = false;
  null_chk.selected     = false;
  unsigned_chk.selected = false;
  
}

function set_up_part () {
  tabname_txt.text = "";
  comment_txt.text = "";
  tabtype_cb.selectedIndex = 0;
}

function set_default_window() {
  	set_up_part();
	set_down_part();
	fields.splice(0, fields.length);
}

//------------------------------------------------------------------------------------------------//
function gen_addtab_xml() {
  	 	 
	   var tabdata_str = "";
	   var tabname = tabname_txt.text;
       
	   tabdata_str = OpenTag("table", "");
	   
	   tabdata_str += OpenTag("name", "") + Cdata(tabname) + CloseTag("name");
	   tabdata_str += OpenTag("dbname", "") + Cdata(parent.ExtendSearch("database", null, parent.metadataxml[parent.current_db])[0].attributes.name)
	                + CloseTag("dbname");
	   tabdata_str += OpenTag("type", "") + Cdata(tabtype_cb.selectedItem)
	                + CloseTag("type");
	   tabdata_str += OpenTag("comment", "") + Cdata(comment_txt.text)
	                + CloseTag("comment");				
	   	  
  	  
	   for(var i = 0; i < fields.length; i++)
		{
		   var row_param = "";
		      
		   row_param += " field_type=\"" + fields[i].field_type + "\"";
		   row_param += " field_size=\"" + fields[i].field_size + "\"";
		   row_param += " unsigned=\"" + fields[i].unsigned + "\"";
		   row_param += " auto_inc=\"" + fields[i].auto_inc + "\"";
		   row_param += " null=\"" + fields[i].null + "\"";
		   
		   row_param += " index=\"" + fields[i].index + "\"";
		   row_param += " prikey=\"" + fields[i].prikey + "\"";
		   row_param += " unique=\"" + fields[i].unique + "\"";
		   
		   tabdata_str += OpenTag("row", row_param);
   	       
		   tabdata_str += OpenTag("field_name", "") + Cdata(fields[i].field_name) + CloseTag("field_name");
		   tabdata_str += OpenTag("default_value", "") + Cdata(fields[i].default_value) + CloseTag("default_value");
		   
		   tabdata_str += CloseTag("row");	   
		 }
		
	   tabdata_str += CloseTag("table");
	
	   //send xml to server
   	   var sendvar  = new LoadVars();
        //type of action
		parent.connect_db(sendvar);
		sendvar.type   = "addtable";
		sendvar.xmldoc = tabdata_str;
				
		var result_xml = new XML();
		result_xml.ignoreWhite = true;
		
		result_xml.onLoad = function (success) {
	          
			  if (! success)  parent.MessageBox("Error loading result xml");
		
			  var res_err = parent.ExtendSearch("mainerror", null, this);
			  			  
			  if (length(res_err[0].childNodes) == 1)
			  {
 				//hide dialog window
				parent.hideWindowPopUp( parent.addtable_mc);	
	              
				//get parent of tables
		           var tabparent_xml = parent.ExtendSearch("database", null, parent.metadataxml[parent.current_db]);
				tabparent_xml[0].appendChild(this.firstChild);
				  
				//update tables array
				parent.tables[parent.current_db] = parent.ExtendSearch("table", null, parent.metadataxml[parent.current_db]);
				  
				/*
				parent.tablist_mc.addItemAt(0,tabname);
				parent.tablist_mc.setSelectedIndex(0);
				parent.tab1_mc.tablist_select(tabname);
                     */
				parent.fill_tablist( parent.current_db );
				parent.MessageBox("Table '" + tabname + "' created succesfully");
				  
				set_default_window();
				  
			      //something whas changed
				parent.change = true;
				 
			  }
			  else 
			  {
				 var args = new Object();
				 args.msg = res_err[0].childNodes;
				 args.name = "on_error_ok_pressed";
				 args.link = parent.addtable_mc.content;
				 
				 parent.showWindowPopUp("message_mc", args);
				 //parent.addtable_mc._visible = true;
			  }
        }
				
		sendvar.sendAndLoad(parent.phpURL, result_xml);
        
}

function on_error_ok_pressed()
{
   //parent.hideWindowPopUp(parent.message_mc);
   parent.message_mc._visible = false;
   parent.showWindowPopUp( "addtable_mc" );
}

function OpenTag(tag, param){		
   return ("<" + tag + " " + param + ">");
}
	
function CloseTag(tag){		
   return ("</" + tag + ">");
}

function Cdata(data){		
   return ("<![CDATA[" + data + "]]>");
}	
//----------------------------------------------------------------------------------------------//

