//----------------------------------------------------------------------------------------------//
init();
stop();
//----------------------------------------------------------------------------------------------//
function init()
{
	parent = _parent._parent; 
 
	//button listener
	btn_listener = new Object();
  
	ok_btn.addEventListener("click", btn_listener);
	cancel_btn.addEventListener("click", btn_listener);
  
	all_left_btn.addEventListener("click", btn_listener);
	left_btn.addEventListener("click", btn_listener);
	all_right_btn.addEventListener("click", btn_listener);
	right_btn.addEventListener("click", btn_listener);
  
	parent.set_def_prop(this);
	
	//init filter object
	if( parent.filter_obj == undefined ) parent.filter_obj = new Object();
	
	left_lst.vScrollPolicy = "auto"; 
	right_lst.vScrollPolicy = "auto"; 
	
	this.Show(this.args);
}
//---
btn_listener.click = function(evt)
{
	switch(evt.target._name)
	{
		case "left_btn"     : left_btn_click(); break;
		case "all_left_btn" : all_left_btn_click(); break;
		case "all_right_btn": all_right_btn_click(); break;
		case "right_btn"    : right_btn_click(); break;
		
		
		case "ok_btn"     : set_filter(); break;
		case "cancel_btn" : parent.hideWindowPopUp(_parent); break;		
	}
}
//---
function Show( args )
{
	this.args = args;
    
	var key = parent.current_db + "_" + args.table;
    
	if(parent.filter_obj[key] == undefined) parent.filter_obj[key] = new Object();
	
	if( parent.filter_obj[key]["show_clm"] == undefined)
	{ 
		parent.filter_obj[key]["show_clm"]   = new Array();
		parent.filter_obj[key]["filter_clm"] = new Array();
		parent.filter_obj[key]["fields"] = "";
	}
	
	info_node = getFilterRec(parent.current_db, args.table);
	info_node["primary_fld"]= "";
	
	var fld_names = parent.getfields( args.table );
	var len = fld_names.length;
	
	var show_clm   = "," + info_node["show_clm"].join(",") + ",";
	var filter_clm = "," + info_node["filter_clm"].join(",") + ",";
		
	var all_clm = ",";
	
	for( var i=0; i<len; i++)
	{ 
		var fld_name = fld_names[i].name;		
		all_clm += fld_name + ",";
		
		if( fld_names[i].prikey == "true" )
		{
			info_node["primary_fld"] = fld_name;
			continue;
		}
		
		if( filter_clm.indexOf(","+fld_name+",") >= 0 ) continue;
		if( show_clm.indexOf(","+fld_name+",") >= 0 ) continue;				
		info_node["show_clm"].push( fld_name );
		
	}
	all_clm += ",";
		
	// delete from arrays unused colums	
	if( tables_changed == true)
	{ 
		for(var i=0; i<info_node["show_clm"].length; i++)
		{
			if( all_clm.indexOf(","+info_node["show_clm"][i]+",") < 0 ) 
			{ 
				info_node["show_clm"].splice(i,1);
				i--;
			}			
		}
		
		for(var i=0; i<info_node["filter_clm"].length; i++)
		{
			if( all_clm.indexOf(","+info_node["filter_clm"][i]+",") < 0 ) 
			{ 
				info_node["filter_clm"].splice(i,1);
				i--;
			}
		}		
	}
	//---
	
	var dP = new Array();
	for(var i=0; i<info_node["show_clm"].length; i++) dP.push( {label : info_node["show_clm"][i] } );
	left_lst.dataProvider  = dP;
	
	var dP = new Array();
	for(var i=0; i<info_node["filter_clm"].length; i++) dP.push( {label : info_node["filter_clm"][i] } );	
	right_lst.dataProvider = dP;	
   
	tables_changed = false;
	this._visible = true;	
}
//---
function getFilterRec(db,table)
{ 
	var key = parent.current_db + "_" + args.table;
	return parent.filter_obj[key];
}
//---
function all_left_btn_click()
{
	moveItems(left_lst, right_lst, true);
}
//--

//---
function all_right_btn_click()
{
	moveItems(right_lst, left_lst, true);
}
//--
function left_btn_click()
{ 
	moveItems(left_lst, right_lst, false);
}
//
function right_btn_click()
{ 
	moveItems(right_lst, left_lst, false);
}
//
function moveItems(src, trg, all)
{	
	if( (src.selectedIndices == undefined || src.selectedIndices.length == 0 ) && !all) return;
	
	var indexes = new Array();
	if( all )
	{
		for(var i=0; i<src.dataProvider.length; i++) indexes.push(i);
	}
	else
	{ 
		indexes = src.selectedIndices;
	}
	
	var dP = trg.dataProvider;	
	for(var i=0; i<indexes.length; i++)
	{
		dP.push( src.dataProvider[indexes[i]] );		
		src.dataProvider[indexes[i]] = undefined;
	}
	for(var i=0; i<src.dataProvider.length; i++)
	{		
		if( src.dataProvider[i] != undefined) continue;
		
		src.dataProvider.splice(i,1);
		i--;
	}
	
	trg.dataProvider = dP;
	src.dataProvider = src.dataProvider;		
}

//---
function set_filter()
{
	var _arr = new Array();
	var fields = new Array();
	
	if(info_node["primary_fld"] != "" && info_node["primary_fld"] != undefined) fields.push("`"+info_node["primary_fld"]+"`");
	
	for(var i=0; i<left_lst.dataProvider.length; i++)
	{
		_arr.push( left_lst.dataProvider[i].label );
		fields.push( "`" + left_lst.dataProvider[i].label + "`" );
	}	
	info_node["show_clm"] = _arr;
	
	var _arr = new Array();
	
	for(var i=0; i<right_lst.dataProvider.length; i++)
	{
		_arr.push( right_lst.dataProvider[i].label );		
	}	
	info_node["filter_clm"] = _arr;
	
	//change button icon
	//parent.tab2_mc.setBtnIcon( info_node );
	
	info_node["fields"] = info_node["filter_clm"].length>0 ? fields.join(",") : "";
	
	parent.tab2_mc.table_dg.removeAllColumns();
	delete parent.tab2_mc.resort;
	delete parent.tab2_mc.table_dg["current_table"];
	//clear all
	//parent.tab2_mc.clear_all();
	
	parent.tab2_mc.getdata(parent.tab2_mc.current_table,0,parent.tab2_mc.step);
	
	parent.hideWindowPopUp(_parent);
}














