﻿import mx.effects.Tween;

init();
stop();
//-------------------------------------------------------------------------------------------------------------------------//
function init()
{
	this._x       = 185;
	this._y       = 32;
	parent = _parent;
	
	current_table = "";
	rec_from      = 0;
	def_step		= 30;
	step		= def_step;
	rec_per_page_txt.text = def_step;
	
	rec_total     = 0;
	
	pos           = -1;
	//change_index  = -1;
	is_empty_row  = false;
	
	total_txt.text= "";
	sql_qry = "";
	
	change_arr    = new Object();
	load_vars     = new Array();
	
	//data grid init   
	table_dg.sortableColumns = true;
	
	//onChange Listener
	//onChange_listener = new Object();
	//table_dg.addEventListener("change", onChange_listener);
	
	//onEdit Listener
	onEdit_listener = new Object();
	table_dg.addEventListener("cellEdit", onEdit_listener);
	table_dg.addEventListener("cellFocusIn", onEdit_listener);	
	//onClick buttons listener
	btn_listener = new Object();
	
	insert_btn.addEventListener("click", btn_listener);
	delete_btn.addEventListener("click", btn_listener);
	next_btn.addEventListener("click", btn_listener);
	prev_btn.addEventListener("click", btn_listener);
	jump_go_btn.addEventListener("click", btn_listener);
	fromto_go_btn.addEventListener("click", btn_listener);
	
	rec_per_page_txt.restrict = "0-9";
	jump_to_page_txt.restrict = "0-9";
	from_txt.restrict = "0-9";
	to_txt.restrict = "0-9";
	total_txt.text = "";
	
	onStep_listener = new Object();
	onStep_listener.change = function( evnt )
	{	  
	  var t = evnt.target;
	  if( t.text == "" || t.text == "0") return;//t.text = def_step;
	  step = Number(t.text);
	  
	  rec_from = 0;	  
	  
	  getdata( current_table, rec_from , step );
	  
	}
	rec_per_page_txt.addEventListener("change", onStep_listener)
	
	rec_per_page_txt.onKillFocus = function()
	{
	  if( this.text == "" || this.text == "0")
	  {
		this.text = def_step;
		step = Number(this.text);	  
		rec_from = 0;	  
		getdata( current_table, rec_from , step );
	  }	  
	  
	}
	
	
	//----------------------------------------------------------
	//add tooltip to copy button
	copy_btn.setToolTip("Copy to clipboard as CSV data",  true);
	copy_btn.addEventListener("click", btn_listener);
	//----------------------------------------------------------
	//add tooltip to filter button
	filter_btn.setToolTip(_parent._DEF_FILTER_TOOLTIP,  true);
	filter_btn.addEventListener("click", btn_listener);
	//----------------------------------------------------------
	
	total_txt.wordWrap = true;
	
	//table_dg.vScrollPolicy = "auto";
	//table_dg.hScrollPolicy = "auto";
	
	//first align all components
	setSize( Stage.width, Stage.height );
	
	table_dg.blobColumns = new Array();
	table_dg.hScrollPolicy = "on";
	
	_parent.set_def_prop(this);  
	this.Show();
}

//--------------------------------------------------------------
function getCSVdata( dp, header, separator )
{
	var ret = new String("");
	trace(dp);
	if( header == undefined ) header = "";
	if(dp == undefined || dp.length == 0) return header;
	if(separator == undefined) separator = ",";	
	
	ret =  header == "" ? "" : header + "\n";
	
	var _data;
	for(var i=0; i<dp.length; i++)
	{
		_data = new Array();
		for( var j in dp[i] ) _data.push( dp[i][j] );
		ret += _data.join( separator ).str_replace(chr(13),"") + "\n";		
		delete _data;
		
	}
	
	ret = ret.substring(0, ret.length - 1);
	
	return ret;
}

function copyToClipboardCSV()
{
	//trace(table_dg.columnNames);
	var str = getCSVdata(table_dg.dataProvider, table_dg.columnNames.join(","), ",");
	System.setClipboard( str );
}

//--------------------------------------------------------------
function clear_all()
{
	table_dg.removeAllColumns();
	table_dg.dataProvider = undefined;
	total_txt.text = "";	
	
	delete resort;		
	setBtnIcon(undefined);
	current_table = "";
	delete filter_node;	
	delete table_dg["current_table"];
}
//---------------------------------------Handlers---------------------------------------------------------------------//
btn_listener.click = function(evt)
{
   if ( _parent.current_db != "" && _parent.tablist_mc.selectedItem.attributes.type == "table")
   switch(evt.target._name)
   {
     case "insert_btn" : if ( !is_empty_row ) add_empty_row();	break;
	case "delete_btn"	: delete_row(table_dg.selectedIndex); break;
	case "next_btn"		: next_press(); break;
	case "prev_btn"		: prev_press(); break;
	case "jump_go_btn"	: jump_press(); break;
	case "fromto_go_btn"	: from_to_press(); break;
	case "copy_btn"		: copyToClipboardCSV();break;
	case "filter_btn"	: filter_press(); break;
   }
}

//--- Filter button press
function filter_press()
{
	var args   = new Object();
	args.title = _parent.titles["filter_tool"] + " " + current_table;
	args.table = current_table;
	_parent.showWindowPopUp("columns_filter", args);
}
//---

/*
//do insert or update when other row was clicked  
onChange_listener.change = function(evt)
{
   var index = evt.target.selectedIndex;
         
   if(index != change_index && change_index != -1)
   {
      //do insert or update
	  if(!is_empty(change_arr))
	  {
	        if ( !is_empty_row ) update(change_index);
	        if ( is_empty_row ) insert(change_index); 
	  }
	  //return
	  change_index = index;
   }
   else 
   { 
	   if (table_dg.length == 1) 
		   if ( is_empty_row ) insert( 0 );
		   else if ( !is_empty(change_arr) ) update( 0 );
	   
	   change_index = index; //for begin work
   }
   
}
*/

function is_empty( item )
{
  for(var i = 0; i < fld_names.length; i++)
  {
	
     if(item[fld_names[i].name] != undefined ) return (false);
  }
  return (true);
}

function empty()
{
	//for(var i = 0; i < fld_names.length; i++) delete (change_arr[fld_names[i].name]);
	stopCheckBlobUpdate();
	delete change_arr;
	change_arr = new Object();	
}

function changeEditCellProp()
{
	delete this.onEnterFrame;
	var edit_txt = table_dg.cellEditor.label
	
	//make multiline
	edit_txt.multiline = true;
	
	//make selection
	Selection.setFocus( edit_txt ); 
	Selection.setSelection(0, edit_txt.length);
	
	//set scroll
	edit_txt.scroll  = 0;
	edit_txt.hscroll = 0;	
	
}

onEdit_listener.cellFocusIn = function ( evt )
{
	evt.target._parent.onEnterFrame = changeEditCellProp;
}

onEdit_listener.cellEdit = function ( evt )
{
  trace("<<EDIT>>");  
        
  var col_index =  evt.columnIndex;
  var row_index =  evt.itemIndex;
  var col_name  =  evt.target.getColumnAt(col_index).columnName;
  
  if (new String(evt.oldValue) != evt.target.getItemAt(row_index)[col_name])
      change_arr[col_name] = evt.oldValue; 
  
  if ( _parent.message_mc._visible || is_empty(change_arr) ) return;
  
  //insert new data
  if( is_empty_row && row_index == (evt.target.length-1))
  {
	insert( row_index, col_index );
	return;
  }
  
  if( is_empty_row )
  { 
	delete_row( evt.target.length-1 );
  }
  
  //update data
  update( row_index , col_index);
  
}
//--------------------------------------------------------------------------------------------------------------------//
function Show()
{
  _parent.tree_listener.change = function(evt) { tab2Handler(evt);}
  _parent.tree_listener.nodeClose = function(evt){ clear_all(); current_table = ""; }
  if ((pos != _parent.tablist_mc.selectedIndex || tables_changed) 
       &&  _parent.tab4_is_qry != true) 
  {
	  var evt = new Object();
	  evt.target = _parent.tablist_mc;
	  evt.is_click = false;
	  tab2Handler(evt);
	  
	  tables_changed = false;
  }
  else if ( _parent.tab4_is_qry && _parent.tab4_xml_qry != undefined)
  { 
      fill_datagrid( _parent.tab4_xml_qry );
      delete _parent.tab4_xml_qry;
  }
  
  this._visible = true;
}

//when table is selected in table list
function tab2Handler( evt )
{
  _parent.change_current_db(evt);
  
  //clear from "select" from tab4
  _parent.tab4_is_qry = false;
  sql_qry = "";
  
  pos = evt.target.selectedIndex;
  var item = evt.target.selectedItem;
  
  //trace("current_table " + current_table);
  clear_all();   
  
  if(item.attributes["type"] == "table")
  {
     //clear_all();
     
	 current_table = evt.target.selectedItem.attributes.label;
	 //get count of records 	 
	 //--------------------
	 is_empty_row = 0;
	 _parent.execute_action("get_record_cnt", {tabname : current_table}, this, "get_record_cnt");
	 rec_total = step + 1;//some tricks	 
	 
	 var fld = _parent.getfields(current_table);
	 
	 //default if table have more as 15 columns we nead show filter window
	 if(fld.length > 15 && _parent.filter_obj[_parent.current_db + "_" + current_table] == undefined )
	 { 
		//show filter window
		filter_press();
	 }
	 else
	 {
		getdata(current_table, 0, step);
	 }
	 //-------------------- 	
  }
  else
  {
	current_table = "";	 
  }   
  
}

function get_record_cnt( xmldoc )
{
	var res = _parent.ExtendSearch("record_cnt", null, xmldoc);
		
	rec_total = res[0].attributes.cnt;
	//trace("rec_total " + rec_total);
	updateTotalLabel();
	 
	//rec_from = 0;
	//rec_to   = Number(rec_per_page_txt.text);
	//getdata(current_table, rec_from, rec_to);
	
}


function setBtnIcon( _node )
{	
	var ico = "filter_ico";
	var msg = parent._DEF_FILTER_TOOLTIP;
	if( _node["filter_clm"].length > 0 )
	{ 
		ico = "filter_red_ico";
		msg += " (filtered "+_node["filter_clm"].length+" columns)";
	}
	
	filter_btn.icon =  ico;
	//change tooltip
	filter_btn._theTooltip.setDisplayText( msg );
}


function getdata( tabname, from, cnt )
{
	if (current_table == "" && !_parent.tab4_is_qry) return;
	
	//trace("FROM - " + from + " tot - " + rec_total + " step " + cnt);
	from = (from == undefined || from < 0 )? 0 : from;
	from = Math.min(from, rec_total-1);
	
	var fields = "";
	
	if(!_parent.tab4_is_qry)
	{ 
		filter_node = _parent.filter_obj[_parent.current_db+"_"+tabname];
		fields = filter_node["fields"];
		fields = fields == undefined ? "" : fields;
		
		setBtnIcon( filter_node );//icon invisible if query	
	}
	
	var params = {
			     tabname  : tabname, 
				from_rec : from,
				cnt_rec  : cnt,
				qry      : sql_qry,
				fields   : fields
			  };	
			  
	for(var i=0; i<load_vars.length; i++)
	{
		var obj = load_vars[i];		
		obj.onLoad = undefined;		
		delete obj;
	}
	
	load_vars.splice(0);
	_parent.showLoader( true );
     load_vars.push(_parent.execute_action("getdata", params, this, "fill_datagrid"));    
     
}

//bottom buttons functions
function next_press()
{
	
	if( rec_from + step >= rec_total) return;
	
	rec_from = Math.min(rec_total-1, rec_from + step);	
	getdata(current_table, rec_from, step);	
	
}

function prev_press()
{
	if( rec_from == 0 ) return;
	rec_from = Math.max(0, rec_from - step );	
	getdata(current_table, rec_from, step);	
	
}

function jump_press()
{	
	if( jump_to_page_txt.text == "" || jump_to_page_txt.text == "0") return;
	
	var max_pages = Math.ceil(rec_total / step)
	if(Number(jump_to_page_txt.text) > max_pages ) jump_to_page_txt.text = max_pages;
	
	getdata(current_table, step*(Number(jump_to_page_txt.text)-1), step);	
}

function from_to_press()
{	
	if(Number(from_txt.text) > rec_total) from_txt.text = rec_total;
	if(Number(to_txt.text)   > rec_total) to_txt.text = rec_total;
	
	if(Number(to_txt.text) < Number(from_txt.text)) to_txt.text = from_txt.text;
	
	getdata(current_table, Number(from_txt.text)-1, Number(to_txt.text) - Number(from_txt.text) + 1);
}

//fill datagrid with data of xml
function fill_datagrid( data_xml )
{		
		//trace(data_xml);
		empty();		
		var dP = new Array(); 		
		var tab = _parent.ExtendSearch("table", null, data_xml)[0];
		
		if( !_parent.tab4_is_qry )
		{ 			
			fld_names = _parent.getfields(current_table);
			
			if(filter_node["filter_clm"].length > 0 )//is filter
			{							
				if(resort == undefined )
				{ 
					this.resort = new Array();
					
					if(filter_node["primary_fld"] != "" && filter_node["primary_fld"] != undefined) 
					{ 
						filter_node["show_clm"].splice(0, 0, filter_node["primary_fld"]);
					}				
				
					for(var i=0; i<filter_node["show_clm"].length; i++)
					{
						for(var j=0; j<fld_names.length; j++)
						{
							if( fld_names[j].name == filter_node["show_clm"][i] )
							{
								resort.push( fld_names[j] );								
								break;
							}
						}
					}				
					if(filter_node["primary_fld"] != "" && filter_node["primary_fld"] != undefined) 
					{ 
						filter_node["show_clm"].splice(0, 1);
					}
				}				
				delete fld_names;
				fld_names = resort;					
			}			
		}
		else
		{	//remove data from previous table
			table_dg.removeAllColumns();			
			
			rec_total = tab.attributes["cnt"];
			sql_qry   =  _parent.converter(_parent.ExtendSearch("sql", null, data_xml)[0].firstChild);
			       
			fld_names = new Array();
			var fields = _parent.ExtendSearch("fields", null, data_xml);
			              
			for(var i = 0; i < fields[0].childNodes.length; i++)
			{ 
				fld_names[i] = new Object();
				fld_names[i].name =  fields[0].childNodes[i];				
			}
		}
		
		
		var rows = _parent.ExtendSearch("row", null, data_xml);		
		rec_from = Math.floor( Number(tab.attributes["from"]) / step) * step;		
		updateTotalLabel();		
		
		if(rows != false)
		{
			for(var i = 0; i < rows.length; i++)
			{
				var asocarr = new Object();
			      for(var j = fld_names.length-1; j>=0 ; j--)
			      {
					asocarr[fld_names[j].name] = _parent.converter(rows[i].childNodes[j]);
				 }
			      dP.push(asocarr);  
			}
		}
		else
		{
			table_dg.removeAllColumns();		
			var asocarr = new Array();
			for(var j = 0; j < fld_names.length ; j++) 
			{ 
				asocarr.push( fld_names[j].name ); 
			}		
			table_dg.columnNames = asocarr;		
		}
		
				
		//*** SET DATAPROVIDER
		table_dg.dataProvider = dP;			
		//***		
		
		var len = table_dg.columnCount;
		var hesh_name = _parent.current_db+current_table+len;
		
		var do_update = table_dg["current_table"] == hesh_name ? false : true;
		
		//clear previous cell renderer
		if( do_update )
		{ 
			for(var i = 0; i < len; i++)
			if( table_dg.blobColumns[i] != undefined )
			{	
				trace("UPDATE******* " + i);
				for(var j=0; j<table_dg.rows.length; j++)
				{
					var cell = table_dg.rows[j].cells[i];
					cell.removeTextField();
					cell.removeMovieClip();
					table_dg.rows[j].cells[i] = undefined;
				}
				delete col.__cellRenderer;
				table_dg.blobColumns[i] = undefined;
			}
		}	
						
		//trace(hesh_name +"  " + do_update);
		for(var i = 0; i < len; i++)
		{
			var col = table_dg.getColumnAt(i);
			
			if( do_update )
			{ 
				var w = get_field_width(col.columnName);			
				if( col.width != w ) 
				{				
					col.width = w;				
				}			
			}
			 	
			
			if( _parent.tab4_is_qry )
			{ 
				col.editable = false;				
			}
			else
			{
				col.editable = true;
			}	  
			
			if( do_update )
			{ 
			
				if( _parent.blob_types[fld_names[i].field_type] == 1 )
				{
					if(col.cellRenderer != "BlobButton") col.cellRenderer = "BlobButton";
					
					col.editable = false;
					table_dg.blobColumns[i] = true;
					
				}//else if(col.cellRenderer != undefined) col.cellRenderer = undefined;
				
				//clear previous cell renderer
				if( table_dg.blobColumns[i] != undefined )
				{	
					for(var j=0; j<table_dg.rows.length; j++)
					{
						var cell = table_dg.rows[j].cells[i];
						cell.removeTextField();
						cell.removeMovieClip();
						table_dg.rows[j].cells[i] = undefined;
					}					
				}
			
			}
			
		}
		
		//store current db/table for more fast DataGrid works
		table_dg["current_table"] = hesh_name;
		//---
		
		filter_btn._visible = insert_btn.enabled = delete_btn.enabled = !_parent.tab4_is_qry;
		
		_parent.showLoader( false );
		
		table_dg.editable = true;
  
   //------------------------------------------------------------------------------------------//
}

function updateTotalLabel()
{	
	var from = rec_total == 0 ? 0 : rec_from+1;
	var spaces = "      ";
	var txt = sql_qry == "" ? "" : "Query view,"+_parent.tab4_exec_msg + "\n";
	txt += "Page " + Math.ceil(from / step) + " of " + Math.ceil(rec_total / step);
	txt += spaces + "Total records: " + rec_total;
	total_txt.text = txt;
	total_txt._y = sql_qry == "" ? 0 : -9;
}

//formulae for field width from string length
function get_field_width( fld_name )
{
   if(length(fld_name) < 5) return (length(fld_name) * 20);
   return (length(fld_name) * 10);
}

//--------------------------------------------------------
//---DATA MANIPULATION
//--------------------------------------------------------

function insert( index, col_index )
{
   var item = table_dg.getItemAt(index);
   var try_insert = false;
   
   if( ! is_empty( item ) )
   {
	current_index = index;
	
	//prepare xml
	var insdata_str = "";
	var tabname = current_table;
       
	insdata_str = OpenTag("table", "");
	   
	insdata_str += OpenTag("name", "") + Cdata(tabname) + CloseTag("name");
	 
	 //id section
	 insdata_str += OpenTag("id", "");	 
	 
	 for(var i = 0; i < fld_names.length ; i++)
	 {
		if (fld_names[i].auto_inc == "true") 
		{
			insdata_str += Cdata(fld_names[i].name); 
			break;
		}
	 }
	 insdata_str += CloseTag("id");
	 
	 //fields section
	 insdata_str += OpenTag("fields", "");	 
	 //for(var i = 0; i < fld_names.length ; i++)
	 {
	    insdata_str += Cdata(fld_names[col_index].name);
	 }
	 insdata_str += CloseTag("fields");
	 
	 //values section
	 insdata_str += OpenTag("values", "");
	 //for(var i = 0; i < fld_names.length ; i++)
	 {
		var i = col_index;
	     var value = item[fld_names[i].name];
	     	     
	     if( length(value) != 0) try_insert = true;
		
		if(length(value) == 0 && (fld_names[i].null == "true" || fld_names[i].auto_inc == "true"))
		{
		   if(_parent.text_types[fld_names[i].field_type] == 0) 
		        value = "NULL";
		   else value = "#%5";
		}
		
		if (length(value) > 1) value = value.split(chr(13)).join("%102");
		else if (length(value) == 0) value = "#%5";
		
		insdata_str += Cdata(value);
	 }
	 insdata_str += CloseTag("values");
			
	
	//correct for filter
	var fields = filter_node["fields"];
	fields = fields == undefined ? "" : fields;
	insdata_str += OpenTag("select_fields", "");
	insdata_str += Cdata(fields);
	insdata_str += CloseTag("select_fields"); 
	//---
	
	
	insdata_str += CloseTag("table");
	
	//do action	
	if( try_insert )	
	{    
	     trace("INSERT->"+insdata_str);
	     table_dg.editable = false;
	    _parent.execute_action("insert", { xmldoc : insdata_str }, this, "insert_done", "insert_fail");
	    rec_total++; 
	}
    
   }
}

//alternative
function add_empty_row()
{
   var asocarr = new Object();
   for(var j = (fld_names.length-1); j >= 0 ; j--) asocarr[fld_names[j].name] = fld_names[j].default_value;
   table_dg.addItem(asocarr);
   _parent.selectGridRowNum( table_dg, (table_dg.length - 1));
   
   empty();
   
   is_empty_row = true;
}

function insert_done( xml )
{        
  table_dg.editable = true;
  trace("insert done");
  change_row(xml);
  is_empty_row = false;
  empty();
  //--update counter
  _parent.execute_action("get_record_cnt", {tabname : current_table}, this, "get_record_cnt");
  //--------------------
}

function insert_fail( xml )
{
	trace("insert fail");
	table_dg.editable = true;
	update_fail( xml );
	//--update counter
	_parent.execute_action("get_record_cnt", {tabname : current_table}, this, "get_record_cnt");
	//--------------------
	is_empty_row = true;
}

function getUpdateXML( index , ins_field_index)
{
	var item = table_dg.getItemAt(index);
	
	current_index = index;
	
	//prepare xml
	var insdata_str = "";
	var tabname = current_table;
     var update = is_empty_row ? 0 : 1;
     
	insdata_str = OpenTag("table", "update='"+update+"'");
	   
	insdata_str += OpenTag("name", "") + Cdata(tabname) + CloseTag("name");
	 	 
	 //id section
	var id_found = undefined;
	insdata_str += OpenTag("id", "");
	
	//_global.dbg(fld_names[0]);
	
	for(var i = 0; i < fld_names.length ; i++)
	{
		if (fld_names[i].prikey == "true" || fld_names[i].unique == "true") 
		{
			insdata_str += Cdata(fld_names[i].name); 
			id_found = fld_names[i].name;
			break;
		}
	}
	insdata_str += CloseTag("id");
	
	//set fields section
	insdata_str += OpenTag("setfields", "");
	if(ins_field_index != undefined) insdata_str += Cdata(fld_names[ins_field_index].name);
	else
	for(var i = 0; i < fld_names.length ; i++)
	{
		if(change_arr[fld_names[i].name] != undefined) insdata_str += Cdata(fld_names[i].name);
	}
	
	insdata_str += CloseTag("setfields");
	
	//fields section
	insdata_str += OpenTag("fields", "");
	for(var i = 0; i < fld_names.length ; i++)
	{
		if(id_found != undefined && id_found != fld_names[i].name) continue;
	
		//----blob problem fix 
		if( _parent.blob_types[fld_names[i].field_type] == 1) continue;
		//----
		
		insdata_str += Cdata(fld_names[i].name);
	}
	insdata_str += CloseTag("fields");
	
	
	//new values section
	insdata_str += OpenTag("newvalues", "");
	for(var i = 0; i < fld_names.length ; i++)
	{
		if(change_arr[fld_names[i].name] != undefined)
		{
			var value = item[fld_names[i].name];
			
			value = value_condition( value, fld_names[i], "NULL" );
			
			insdata_str += Cdata(value);
		}
	}
	insdata_str += CloseTag("newvalues");
	
	//old values section     
	insdata_str += OpenTag("oldvalues", "");
	for(var i = 0; i < fld_names.length ; i++)
	{
		var fld_name = fld_names[i].name;
		
		if(id_found != undefined && id_found != fld_name) continue;		
		//----blob problem fix 
		if( _parent.blob_types[fld_names[i].field_type] == 1) continue;
		//----
		
		insdata_str += OpenTag( "_"+i, "" );
		var value = change_arr[fld_name];
		if (value == undefined) value = item[fld_name];
		
		value = value_condition( value, fld_names[i], "NULL" );
		
		insdata_str += Cdata(value);
		
		insdata_str += CloseTag( "_"+i );
	}
	insdata_str += CloseTag("oldvalues"); 
	
	//correct for filter
	var fields = filter_node["fields"];
	fields = fields == undefined ? "" : fields;
	insdata_str += OpenTag("select_fields", "");
	insdata_str += Cdata(fields);
	insdata_str += CloseTag("select_fields"); 
	//---
	 
	 
	insdata_str += CloseTag("table");
	
	//trace( insdata_str );
	
	return insdata_str;
}

function update( index, col_index )
{
   var item = table_dg.getItemAt(index);
	
   if(!is_empty(item) && !is_empty(change_arr) )
   {	
	
	insdata_str = getUpdateXML( index, col_index );	
	//do action
	//trace("UPDATE->" + insdata_str);
	table_dg.editable = false;
	_parent.execute_action("update", {xmldoc:insdata_str}, this, "update_done", "update_fail");
   
   }//end if
}

//alternative
function update_done( xml )
{
  trace("update done");
  table_dg.editable = true;
  change_row(xml);   
  empty();
}

function update_fail( xml )
{
  trace("update fail");
  table_dg.editable = true;
  for(var i = 0; i < fld_names.length; i++)
  {
	  var tmp_value = change_arr[fld_names[i].name];
	  if (tmp_value == undefined) continue;
	  table_dg.editField(current_index, fld_names[i].name, tmp_value);

	  item[fld_names[i].name] = value;
  }
  empty();
}

function delete_row( index )
{
   var item = table_dg.getItemAt(index);
   
   
   if( index == undefined || item == undefined ) return;
   if( is_empty_row ) 
   { 
	   is_empty_row = false;
	   table_dg.removeItemAt( index );
	   trace("delete empty");
	   return;
   }
   
   //if( !is_empty(item) )
   {/*
	current_index = index;
	
	//prepare xml
	var insdata_str = "";
	var tabname = current_table;
       
	insdata_str = OpenTag("table", "");
	   
	insdata_str += OpenTag("name", "") + Cdata(tabname) + CloseTag("name");
	 	 
	 //id section
	 insdata_str += OpenTag("id", "");
	 for(var i = 0; i < fld_names.length ; i++)
	 {
	    if (fld_names[i].prikey == "true") 
		{
			insdata_str += Cdata(fld_names[i].name); 
			break;
		}
	 }
	 insdata_str += CloseTag("id");
	 	 
	 //fields section
	 insdata_str += OpenTag("fields", "");
	 for(var i = 0; i < fld_names.length ; i++)
	 {
	    insdata_str += Cdata(fld_names[i].name);
	 }
	 insdata_str += CloseTag("fields");
	  
     //values section
	 insdata_str += OpenTag("values", "");
	 for(var i = 0; i < fld_names.length ; i++)
	 {
		var value = item[fld_names[i].name];
		
		value = value_condition( value, fld_names[i], "IS NULL" );
		
		insdata_str += Cdata(value);
	 }
	 insdata_str += CloseTag("values"); 
	  
	insdata_str += CloseTag("table");*/
	
	insdata_str = getUpdateXML(index);
	
	//do action
	trace("DELETE->" + insdata_str);
	_parent.execute_action("delete", {xmldoc:insdata_str}, this, "delete_done", "delete_fail");
   
   }//end if
}

function delete_done( xml )
{
  trace("delete done");
  table_dg.removeItemAt(current_index);
  set_position();
  
  //--update counter
  _parent.execute_action("get_record_cnt", {tabname : current_table}, this, "get_record_cnt");
  //--------------------
}

function set_position()
{
  if(current_index < table_dg.length-1) table_dg.selectedIndex = current_index;
  else table_dg.selectedIndex = table_dg.length-1;
}

function delete_fail( xml )
{
   trace("delete fail");
}

function change_row( xml )
{
  var newrow = _parent.ExtendSearch("row", null, xml);
  
  //trace("new " + newrow );
  
  if (newrow != false)
  { 
	  for(var j = (fld_names.length-1); j >= 0 ; j--) 
	  { 
  
	      table_dg.editField(current_index, fld_names[j].name, _parent.converter(newrow[0].childNodes[j]));
	  }
  }
  else
  {
	  var item = table_dg.getItemAt(current_index);
	  for(var j = (fld_names.length-1); j >= 0 ; j--) 
	  { 
  
	      if (fld_names[j].field_size != 0 && 
	          fld_names[j].field_size != undefined && 
	          fld_names[j].field_size != "") 
	      { 
	          
	          var val = item[fld_names[j].name].substr(0, Number(fld_names[j].field_size));
	          if (val == undefined) val = fld_names[j].default_value;
	          table_dg.editField(current_index, fld_names[j].name, val);
	         
	      }
	  }
	  
  }	
}

function value_condition( value, field, text_type )
{
	if(value == "" && field.null == "true")
	{
	   if(_parent.text_types[field.field_type] == 0) value = text_type;
	   else value = "#%5";
	}
		
		
	if(value == "" || value == undefined) value = "#%5";
	else 	value = _parent.str_replace(value, chr(13), "%102");
	
	value = _parent.str_replace(value, "]", "%103");
		
	return ( value );
}

function OpenTag( tag, param )
{		
   return ("<" + tag + " " + param + ">");
}
	
function CloseTag( tag )
{		
   return ("</" + tag + ">");
}

function Cdata( data )
{		
   return ("<![CDATA[" + data + "]]>");
}
//-------------------------------------------------------------------------------------------------------------------------//

function startCheckBlobUpdate( sid )
{	
	stopCheckBlobUpdate();
	updID = setInterval(checkBlobUpdate, 2000, sid, this);
}

function stopCheckBlobUpdate()
{
	clearInterval(updID);
	
	/*var snd = new LoadVars();	
	snd.ses_id = result_xml.sid;
	snd.sendAndLoad( _parent.absolutePhpURL+"clear_session.php", snd );	*/
	
	result_xml.onLoad = function(){} ;
	delete result_xml;	
}

function checkBlobUpdate( sid , parent)
{ 
	parent.stopCheckBlobUpdate();	
	
	var sendvar = new LoadVars();
	
	sendvar.ses_id = sid;
	
	result_xml = new XML();
	result_xml.ignoreWhite = true;
	result_xml.parent = parent;
	result_xml.sid = sid;	

	result_xml.onLoad = function ( success )
	{ 
		
		parent._parent.debug_txt.text += "\n" + this.sid;
		
		if( !success || this.status != 0 ) return;
		
		var root_xml = this.firstChild;
		trace(root_xml.attributes["upd"]);
		if( root_xml.attributes["upd"] != 0 )
		{	
			if( this.parent.is_empty_row )
			{//insert
				this.parent.insert_done( this );
			}
			else
			{
				this.parent.update_done( this );			
			}			
			
		}
		else 
		{ 			
			this.parent.startCheckBlobUpdate( this.sid );		
		}		
	}
	
	sendvar.sendAndLoad(_parent.absolutePhpURL+"check_update.php", result_xml);	
}



//--------------------------------------------------------------------------------
//---make resize ability
//--------------------------------------------------------------------------------
function setSize( w,h )
{	
	var p = _parent;
	
	this._x = p.tablist_mc._x + p.tablist_mc.width + 10;
	this._y = p.tab1_mc._y + p.tab1_mc.addtab_btn._y;//p.tablist_mc._y;
	
	total_txt._width = w - this._x - total_txt._x - 10;
	
	var g_w = total_txt._x + total_txt._width;
	var g_h = p.tablist_mc.height - table_dg._y - 30;
	
	table_dg.setSize(g_w,g_h);
	
	var point = new Object();
	point.x = p.logout_btn._x;
	point.y = p.logout_btn._y;
	globalToLocal( point );
	var dy = point.y - rect_per_pg_lbl._y;
	var dx = (total_txt._x + total_txt._width) - next_btn.width - next_btn._x;
	
	rec_per_page_txt._y += dy - 25;
	rect_per_pg_lbl._y  += dy - 25;
	
	var group = Array("jump_to_pg_lbl","show_pg_lbl","through_pg_lbl","from_txt","jump_to_page_txt",
	                  "to_txt", "jump_go_btn", "fromto_go_btn", "prev_btn", "next_btn" );
	
	for(var i=0; i<group.length; i++)
	{
		this[group[i]]._y += dy - 25;
		this[group[i]]._x += dx - 10;
	}

}
