﻿
class com.RelationLine extends MovieClip
{
	var lineColor = 0x000000;
	
	var table_1 : Object;
	var table_2 : Object;
	
	var r_el_1 : MovieClip;
	var r_el_2 : MovieClip;
	
	var owner : MovieClip;
	//relationInfo.key_table - key table 
	//relationInfo.name - source column
	//relationInfo.ref_table - reference table
	//relationInfo.ref_field - target column
	var relationInfo : Object;
	
	
	//table object - t.table - movie clip t.fname - field name
	function RelationLine()
	{ 		
		owner = _parent;
		this.attachMovie("relation_el", "r_el_1", 2);
		this.attachMovie("relation_el", "r_el_2", 3);			
		
		this.onRelease = onRelease;
	}
	
	function addTables(t1:Object, t2:Object, rInfo : Object)
	{
		table_1 = t1;		
		table_2 = t2;	
		
		if( table_1.table.relationSet == undefined) table_1.table.relationSet = new Array();
		if( table_2.table.relationSet == undefined) table_2.table.relationSet = new Array();
		
		t1.table.relationSet.push(this);
		t2.table.relationSet.push(this);
		
		relationInfo = rInfo;
		
		if( rInfo.key_table == t1.table.tabName ) { r_el_1.gotoAndStop("key");r_el_2.gotoAndStop("no_key");}
		if( rInfo.key_table == t2.table.tabName ) { r_el_2.gotoAndStop("key");r_el_1.gotoAndStop("no_key");}
				
	}
	
	function drawLine( gauge )
	{ 
		this.clear();
		this.lineStyle( gauge, lineColor);
		
		var xS,yS,xE,yE : Number;
		
		yS = r_el_1._y;
		yE = r_el_2._y;
		
		xS = table_1.table._x <= table_2.table._x ? r_el_1._x + r_el_1._width : r_el_1._x;
		xE = table_1.table._x >= table_2.table._x ? r_el_2._x + r_el_2._width : r_el_2._x;
		
		if(table_1.table == undefined || table_2.table == undefined)
		{
			this.clear();
			return;
		}
		this.moveTo(xS,yS);
		this.lineTo(xE,yE);
		//make more fine accesibility for line click
		lineStyle(7,0,0);
		this.moveTo(xS,yS);
		this.lineTo(xE,yE);
		
		
	}
	
	function drawRelation()
	{	
		r_el_1._x = table_1.table._x + (table_1.table._x > table_2.table._x ? -r_el_1._width : table_1.table.width );//to do make it
		r_el_2._x = table_2.table._x + (table_1.table._x < table_2.table._x ? -r_el_2._width : table_2.table.width );//to do make it
		
		r_el_1._y = table_1.table.getFieldYbyName(table_1.fname);
		r_el_2._y = table_2.table.getFieldYbyName(table_2.fname);
		
		drawLine(1);
	}
	
	function onRelease()
	{	
		var c = this;
		if(!c.doubleClick()) return;
		
		drawAsSelected( true );
		owner.editRelationShip(this);
	}
	
	
	function drawAsSelected( _selected )
	{
		var my_color = new Color(this);
		var c = !_selected || _selected==undefined ? 0x000000 : 0xFF0000;
		my_color.setRGB( c );				
	}	
	
	function clearRelation()
	{
		owner.relationsCounter--;
		
		this._visible = false;
		this.clear();
		this._x = this._y = r_el_1._x = r_el_2._x = 0;
		r_el_1._y = r_el_2._y = 0;
		
		delete relationInfo;
		for(var i=0; i < table_1.table.relationSet.length; i++)
		{
			if(table_1.table.relationSet[i] == this)
			{
				delete table_1.table.relationSet[i];
				break;
			}
			if(table_2.table.relationSet[i] == this)
			{
				delete table_2.table.relationSet[i];
				break;
			}
		}
		
	}
	
}