﻿
class com.ResizerManager extends MovieClip
{
	
	var owner : MovieClip;
	
	var objects : Array;
	
	var old_width : Number;
	var old_height: Number;
	
	
	static var isSetsProto = false;
	
	//constructor
	function ResizerManager()
	{
		owner = this._parent;
		initProto();
		old_width  = owner._width;
		old_height = owner._height;			
		
		addObjects();				
	}
	
	
	function initProto()
	{
		if( isSetsProto ) return;
		isSetsProto = true;
		
		var Anchors = new Object();
		Anchors["left"]   = true;
		Anchors["top"]    = true;
		Anchors["right"]  = false;
		Anchors["bottom"] = false;

		//MovieClip.prototype.Anchors = new Object();
		//TextField.prototype.Anchors = new Object();
		
		trace("set proto");	
	}
	
	function addObjects()
	{
		delete objects;
		objects = new Array();
		
		var obj;
		for( var obj_name in owner )
		{
			obj = owner[ obj_name ];
			
			if(! isTrustedObject(obj) ) continue;
			
			trace(obj_name + " -> " + obj.Anchors["left"]);
			
			objects.push( obj );
			
		}
		
	}
	
	function isTrustedObject( obj )
	{
		if( obj instanceof mx.controls.Button ) return true;
		else
		if(obj instanceof TextField) return true;
		else
		if(obj instanceof mx.controls.TextInput) return true;
		
		return false;
	}
	
	function removeElement( _arr:Array, obj)
	{
		//first remove from moved_objects array
		for(var i=0; i < _arr.length; i++)
		{
			if(_arr[i] == obj)
			{
				_arr.splice( i, 1 );//delete object
				break;
			}
		}		
	}
	
	//set size
	function setSize(w,h)
	{
		var dx = w - old_width;
		var dy = h - old_height;
		old_width = w;
		old_height= h;
		//owner._xscale = owner._yscale = 100;
		
		var len = objects.length;
		var obj,anchors;
		var doX,doY,doW,doH;
		
		for(var i=0; i < len; i++)
		{
			obj = objects[i];
			anchors = obj.Anchors;
			
			doX = doY = doW = doH = 0;
			
			
			if( anchors.left && anchors.right ){	doW = obj.width  + dx; }
			if( anchors.top && anchors.bottom ){ doH = obj.height + dy; }
			
			if( !anchors.left && anchors.right ){ doX = obj._x + dx; }
			if( !anchors.top && anchors.bottom ){ doH = obj._y + dy; }
			
			
			if( doW > 0 || doH >0 )
			{
				doW = doW <=0 ? obj.width : doW;
				doH = doH <=0 ? obj.height : doH;
				obj.setSize(doW, doH);
			}
			
			if( doX > 0 ) obj._x = doX;
			if( doY > 0 ) obj._y = doY;
			
		}
		
		
	}
	
}