﻿import com.RelationLine;

class com.TablesManager extends MovieClip
{
	
	var cursors_mc : MovieClip;
	var tablesDepfh = 500;
	var linesDepfh  = 20;
	var dragedFieldDeph = 1800;
	var dragedField : MovieClip;
	
	var tables_arr : Array;//stored all tables
	var myRoot : MovieClip;//root movie clip
		
	var relashions_arr : Array;//stored all relations
	
	var tableCounter : Number = 0;
	var relationsCounter : Number = 0;
	
	var defTableWidth  : Number = 100;
	var defTableHeight : Number = 150;
	
	var doCollapseTables : Boolean;//flag layout tables
	
	var editedRelations : Array = new Array();	
	
	
	function TablesManager()
	{
		//create empty movieclip for fix scroll pane
		createEmptyMovieClip("_base_" , 10);
		this["_base_"]._visible = false;
		this["_base_"].drawRect(0,0,10,10,2,0xFFCC55);	
		//attach cursors movie clip
		attachMovie("cursors", "cursors_mc", 3000);
		cursors_mc._visible = false;
		cursors_mc._xscale = 150;
		cursors_mc._yscale = 150;
		
		myRoot = _parent._parent._parent;
		tables_arr = new Array();
		relashions_arr = new Array();
			
		createChildren();				
	}
	
	
	//load content from new database
	function loadNewDBContent( )
	{	
		myRoot.showLoader( true );
		var len = tables_arr.length;
		for(var i=0; i<len; i++)
		{ 
			tables_arr[i].clearTable();			
		}
		configureScrollPane();
		tableCounter = relationsCounter = 0;
		
		createChildren();
		trace("LOAD DB CONTENT");
	}
	
	function configureScrollPane()
	{ 
		if(_width  < _parent.width)  _parent.hPosition = 0;
		if(_height < _parent.height) _parent.vPosition = 0;		
		_parent.setScrollProperties(_width, 1, _height, 1); 				
	}
	
	function changeCursor( cursor_name )
	{ 
		if(cursor_name == undefined)
		{
			cursors_mc._visible = false;
			Mouse.show();
			cursors_mc.stopDrag();			
			return;
		}
		
		
		cursors_mc.gotoAndStop( cursor_name );			
		cursors_mc.startDrag(true);		
		cursors_mc._x = _xmouse;
		cursors_mc._y = _ymouse;
		Mouse.hide();
		cursors_mc._visible = true;	
	}	
	
	//start drag field
	function startDragField( table, lineNum )
	{ 
		var field = table.getFieldByNum(lineNum);		
		
		if(dragedField == undefined)
		{ 
			createEmptyMovieClip("dragedField", dragedFieldDeph);
			var d = this["dragedField"];
			d.createTextField("_txt", 1, 0, 0, table._width, 20);
			//d._txt.autoSize = true;
			d._txt.background = true;
			//d._txt.border = true;
			d._txt.selectable = false;			
			d._txt.html = true;			
			d._txt.backgroundColor = table.BACKCOLOR;	
			
			//border					
			d.attachMovie("RectBorder", "border_mc", 2, {styleName:this});
			
			//var tf = table.list_txt.getTextFormat();
			//d._txt.setNewTextFormat( tf );			
		}
		else var d = this["dragedField"];
		
		d._txt.htmlText = "<center><b>&nbsp;"+field.name+"</b></center>";	
		var tf = table.list_txt.getTextFormat();
		tf.align = "center";
		d._txt.setTextFormat( tf );
		var bullet_ext = 45;
		d._txt._width  = d._txt.textWidth + bullet_ext;
		d._txt._height = d._txt.textHeight+ 5;
		d.border_mc.setSize(d._txt._width, d._txt._height);
		
		//d._txt._width  = tf.getTextExtent("<b>"+field.name+"</b>").textFieldWidth;
		//d._txt._height = tf.getTextExtent("<b>"+field.name+"</b>").textFieldHeight;
		
		d.source_table = table;
		d.source_field = field;
		
		
		d._x = _xmouse - 10;//table._xmouse - (bullet_ext-10)/2;//d._width/2;
		d._y = _ymouse - d._height/2;
		
		d.startDrag();
		d._visible = true;
	}
	
	
	//stop drag field
	function stopDragField( )
	{	
		dragedField._visible = false;
		dragedField.stopDrag();	
		
		var dropObj = eval(this.dragedField._droptarget);
		
		if( dropObj._name != "list_txt" || dropObj._parent.fieldsList == undefined ||
		    dropObj._parent == dragedField.source_table) 
		{ 
			return;
		}
		
		var field = dropObj._parent.getFieldByY( dropObj._ymouse );
		if( field == undefined ) return;
		
		//find if relation exists
		for(var i=0; i < dragedField.source_table.relationSet.length; i++)
		{	var r = dragedField.source_table.relationSet[i].relationInfo;
			if( r.key_table == dragedField.source_table.tabName &&
			    r.name == dragedField.source_field.name &&
			    r.ref_table == dropObj._parent.tabName &&
			    r.ref_field == field.name
			    
			  )return;//relation exists!
		}
		//---
		
		createNewRelationShip(dragedField.source_table, dragedField.source_field, dropObj._parent, field);
		
	}
	
	
	//edit existen relation ship
	function editRelationShip( relation )
	{
		//show popup window		
		var  args = new Object();
		args.link = this;
		args.name = "edit_create_relation";
		args.relation = relation;
		args.update = true;		
		args.title= myRoot.titles["relatioShipWin_update"];
		
		args.type = "update";
		
		myRoot.showWindowPopUp("relatioShipWin", args);
	}
	
	//create new relation ship
	function createNewRelationShip(sourceTable, sourceField, targetTable, targetField)
	{
		//show popup window
		var  args = new Object();
		args.link = this;
		args.name = "edit_create_relation";
		args.relation = new Object();
		args.relation.relationInfo = new Object();
		args.relation.relationInfo["key_table"] = sourceTable.tabName;
		args.relation.relationInfo["name"] = sourceField.name;
		args.relation.relationInfo["ref_table"] = targetTable.tabName;
		args.relation.relationInfo["ref_field"] = targetField.name;
		args.title= myRoot.titles["relatioShipWin_create"];
		
		args.type = "new";
		
		myRoot.showWindowPopUp("relatioShipWin", args);
	}
	
	
	function edit_create_relation( args )
	{
		//trace("edit_create_relation " + args.on_delete + " "+args.on_update+" "+args.type);		
		var type = args.type;
		var params = new Object();
		params = args.relation.relationInfo;
		params.on_delete = args.on_delete;
		params.on_update = args.on_update;	
		
		params.old_on_delete = args.old_on_delete;//for recreate if update failed
		params.old_on_update = args.old_on_update;	//for recreate if update failed
		
		params.relation  = args.relation._target;
		
		myRoot.execute_action(type, params, this, "edit_create_relation_result", undefined, undefined, "edit_create_relation.php");
	}
	
	function edit_create_relation_result( _xml )
	{		
		var root_xml = _xml.firstChild;	
		var atr = root_xml.childNodes[1].attributes;
		
		var relation = eval(atr.relation);		
		
		if(atr.type == "delete")
		{			
			relation.clearRelation();			
		}		 
		else
		if( atr.type == "update" || atr.type == "new" )
		{			
			if( relation != undefined )
			{ 
				editedRelations.push( relation );
				relation.enabled = false;
			} 
			loadRelationShipInfo( atr.table );			
		}
		
		if( atr.type != "new" )
		  myRoot.MessageBox(myRoot.success_msg["rel_"+atr.type+"_success"]);
		
	}
	
	
	function layoutTables(maxY)
	{		
		
		var len = tableCounter;//tables_arr.length;
		var maxW = _parent.width;
		var curX, curY, curW : Number;
		var dx = 30;
		
		maxY = (maxY == undefined ? 10 : maxY);
		
		curX = 10;
		curY = maxY; 
		curW = 0
		
		for(var i=0; i < len; i++)
		{
			var table = tables_arr[i];
			table._visible = true;
			if( table.is_aligned ) continue;
			
			//table.setSize( defTableWidth, defTableHeight);
			
			table._x = curX;
			table._y = curY;
			
			curX = table._width + curX + dx;
			curW = table._width + curX;			
			
			if(curW > maxW)
			{
				curX = 10;
				curY = tables_arr[i-1]._y + tables_arr[i-1]._height + dx;
			}			
		}
		
		configureScrollPane();
		myRoot.showLoader( false );
	}
		
	
	function createChildren()
	{	
		
		var tables = myRoot.gettablesAndField("InnoDB");
		
		var i = 0;
		for(var tname in tables)
		{
			var fields = tables[tname];			
						
			var c;
			
			if(tables_arr[tableCounter] == undefined)
			{ 
				attachMovie("Table", "table"+tablesDepfh, tablesDepfh);
				//trace("ATTACH TABLE " + tname);
				c = this["table"+tablesDepfh];
				tables_arr.push( c );										
				tablesDepfh++;
				c._visible = false;
			}else
			{				
				//tables_arr[tableCounter]._visible = true;
				c = tables_arr[tableCounter];
			}						
			
			c.setSize( defTableWidth, defTableHeight);			
			c.setHeaderCaption( tname );			
			c.setFieldsList( fields );						
			c.tabName = tname;
			tableCounter++;				
		}
		
		//layouut tables
		//layoutTables();
		loadTablesLayout();
		
		//show/hide info message		
		_parent._parent.info_txt._visible = tableCounter == 0 ? true : false;
		//var total = _parent._parent.metadataxml[_parent._parent.current_db].childNodes[0].length;
		//_parent._parent.db_count_txt.text = "Found " + tableCounter+" InnoDB tables (total "+total+").";
		
		if(tableCounter < 2) return;
		
		doCollapseTables = true;
		//load relation ships
		//loadRelationShipInfo();		
	}

	function loadRelationShipInfo( tableName )
	{
		clearInterval(intID);
		var type = "loadRelationShipInfo";
		var params = new Object();
		if(tableName != undefined)	params.one_table = tableName;		
	
		myRoot.execute_action(type, params, this, "createRelationShip", undefined, undefined, "getRelationsInfo.php");
	}
	
		
	function createRelationShip( _xml )
	{		
		var root_xml = _xml.firstChild;		
		
		//first node ALWAYS is "mainerror"
		for(var i=1; i<root_xml.childNodes.length; i++)
		{
			var table = root_xml.childNodes[i];			
			
			for(var j=0; j<table.childNodes.length; j++)
			{
				var field = table.childNodes[j];
				
				field.attributes["key_table"] = table.nodeName;
				var tl = new Object();
				tl.table = getTableByMame(table.nodeName);
				tl.fname = String(field.attributes["name"]);
				
				var tr = new Object();
				tr.table = getTableByMame(field.attributes["ref_table"]);
				tr.fname = String(field.attributes["ref_field"]);
				
				var lname = "RelationShip"+linesDepfh;
				var theLine;
				
				//release edited relation
				editedRelations.pop().clearRelation();
				//---
				
				if( relashions_arr[relationsCounter]==undefined )
				{ 
					this.attachMovie("RelationLine", lname, linesDepfh++);
					theLine = this[lname]
					relashions_arr.push( theLine );
				}
				else
				{ 
					theLine = getFirsFreeRelation();//relashions_arr[relationsCounter];				         
					theLine._visible = true;
				}
				
				relationsCounter++;				
								
				theLine.addTables(tl, tr, field.attributes);
				theLine.drawRelation();	
				theLine.enabled = true;
			}			
			
		}
		
		//collapseAllTablesWithoutRel();		
	}
	
	function getFirsFreeRelation()
	{		
		for(var i=0; i<relashions_arr.length; i++)
		  if( relashions_arr[i]._visible == false && relashions_arr[i].relationInfo == undefined ) 
		    return relashions_arr[i];
		
		return false;
	}
	
	function collapseAllTablesWithoutRel()
	{
		if( ! doCollapseTables )return;
		delete doCollapseTables;
		//collapse all tables withaut links
		var len = tableCounter;//tables_arr.length;
		for(var i=0; i<len; i++)
		{
			var _hide = tables_arr[i].relationSet == undefined || tables_arr[i].relationSet.length==0 ? true : false;
			tables_arr[i].hideBody( _hide );
		}
	}
	
	//return movie clip by table name
	function getTableByMame( tname : String)
	{ 
		for(var i=0; i < tableCounter; i++)
		{ 
			if(tables_arr[i].tabName == tname) return tables_arr[i];
		}
	}
	
	function saveTablesLayout()
	{	
		if( tableCounter < 1) return;
		
		var saveStr = "";
		for(var i=0; i<tableCounter; i++)
		{			
			var table:com.Table = tables_arr[i];
			saveStr += table.tabName + "*" + 
					table._x + "*" +
					table._y + "*" +
					table.width + "*" +
					table.height + "*" +
					(table.isExpanded()?1:0)+
					"<|>";
		}
		
		
		//trace(saveStr);
		var type = "save";
		var params = new Object();			
		params.savestr = saveStr;
		params.current_db = myRoot.current_db;		
	
		myRoot.execute_action(type, params, this, "saveTablesLayout_done", undefined, undefined, "save_tables.php");
	}
	
	function saveTablesLayout_done( _xml )
	{		
		myRoot.MessageBox(myRoot.success_msg["layout_saved"]);
	}
	
	function loadTablesLayout()
	{
		var type = "load";
		var params = new Object();					
		params.current_db = myRoot.current_db;		
		
		myRoot.execute_action(type, params, this, "loadTablesLayout_done", undefined, undefined, "save_tables.php");
	}
	var intID;
	function loadTablesLayout_done( _xml )
	{		
		trace(_xml);
		var root_xml = _xml.firstChild;		
		
		//first node ALWAYS is "mainerror"		
		var _arr = root_xml.childNodes[1].childNodes[0];
		_arr = myRoot.converter( _arr );
		_arr = _arr.split("<|>");
		var maxY = 10;
		for(var i=0; i<_arr.length-1; i++)
		{
			var table_info = _arr[i].split("*");
			var table = getTableByMame(table_info[0]);
			table._x = Number(table_info[1]);
			table._y = Number(table_info[2]);
			table.setSize(Number(table_info[3]),Number(table_info[4]));
			table.hideBody( table_info[5] == 0 );		
			table.is_aligned = true;
			
			maxY = Math.max(maxY, Number(table_info[2]) + Number(table_info[4]) + 10);
		}
				
		layoutTables(maxY);
		
		loadRelationShipInfo();	
		//clearInterval(intID);
		//intID = setInterval(this, "loadRelationShipInfo", 100);
		
	}

}
